(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('rxjs')) :
	typeof define === 'function' && define.amd ? define('ng-google-maps-loader', ['exports', '@angular/core', '@angular/common', 'rxjs'], factory) :
	(factory((global['ng-google-maps-loader'] = {}),global.ng.core,global.ng.common,global.rxjs));
}(this, (function (exports,core,common,rxjs) { 'use strict';

var NgGoogleMapsLoaderConfig = new core.InjectionToken('ng google maps loader config');
var LoadStatus = { NotLoaded: 0, Loading: 1, Loaded: 2, };
LoadStatus[LoadStatus.NotLoaded] = "NotLoaded";
LoadStatus[LoadStatus.Loading] = "Loading";
LoadStatus[LoadStatus.Loaded] = "Loaded";
var NgGoogleMapsLoaderService = /** @class */ (function () {
    function NgGoogleMapsLoaderService(document, ngGoogleMapsLoaderConfig, rendererFactory) {
        this.document = document;
        this.ngGoogleMapsLoaderConfig = ngGoogleMapsLoaderConfig;
        this._loadStatusSubject = new rxjs.BehaviorSubject(LoadStatus.NotLoaded);
        this._loadScriptId = 'ng-google-maps-loader-script-id';
        this._renderer2 = rendererFactory.createRenderer(null, null);
    }
    Object.defineProperty(NgGoogleMapsLoaderService.prototype, "loadScipt", {
        get: function () {
            return this._loadScript;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgGoogleMapsLoaderService.prototype, "loadSciptId", {
        get: function () {
            return this._loadScriptId;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgGoogleMapsLoaderService.prototype, "loadStatus", {
        get: function () {
            return (this._loadStatusSubject);
        },
        enumerable: true,
        configurable: true
    });
    NgGoogleMapsLoaderService.prototype.load = function () {
        if (this.document.getElementById(this._loadScriptId)) {
            return;
        }
        this._loadStatusSubject.next(LoadStatus.Loading);
        var googleMapsApiUrl = this.createGoogleMapsApiUrl();
        this._loadScript = this.createLoadScript(googleMapsApiUrl);
        this._renderer2.appendChild(this.document.body, this._loadScript);
    };
    NgGoogleMapsLoaderService.prototype.createGoogleMapsApiUrl = function () {
        return [
            'https://maps.googleapis.com/maps/api/js',
            "?key=" + this.ngGoogleMapsLoaderConfig.key,
            "&libraries=" + this.ngGoogleMapsLoaderConfig.libraries.join(','),
            "&language=" + (this.ngGoogleMapsLoaderConfig.language || 'en'),
        ].join('');
    };
    NgGoogleMapsLoaderService.prototype.createLoadScript = function (googleMapsApiUrl) {
        var script = this._renderer2.createElement('script');
        script.setAttribute('defer', '');
        script.setAttribute('async', '');
        script.type = 'text/javascript';
        script.id = this._loadScriptId;
        script.src = googleMapsApiUrl;
        script.onload = this.scriptOnLoad.bind(this);
        return script;
    };
    NgGoogleMapsLoaderService.prototype.scriptOnLoad = function () {
        this._loadStatusSubject.next(LoadStatus.Loaded);
        this._loadStatusSubject.complete();
    };
    return NgGoogleMapsLoaderService;
}());
NgGoogleMapsLoaderService.decorators = [
    { type: core.Injectable, args: [{
                providedIn: 'root'
            },] },
];
NgGoogleMapsLoaderService.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] },] },
    { type: NgGoogleMapsLoaderConfig, decorators: [{ type: core.Inject, args: [NgGoogleMapsLoaderConfig,] },] },
    { type: core.RendererFactory2, },
]; };
NgGoogleMapsLoaderService.ngInjectableDef = core.defineInjectable({ factory: function NgGoogleMapsLoaderService_Factory() { return new NgGoogleMapsLoaderService(core.inject(common.DOCUMENT), core.inject(NgGoogleMapsLoaderConfig), core.inject(core.RendererFactory2)); }, token: NgGoogleMapsLoaderService, providedIn: "root" });
var NgGoogleMapsLoaderModule = /** @class */ (function () {
    function NgGoogleMapsLoaderModule() {
    }
    NgGoogleMapsLoaderModule.forRoot = function (ngGoogleMapsLoaderConfig) {
        return {
            ngModule: NgGoogleMapsLoaderModule,
            providers: [
                {
                    provide: NgGoogleMapsLoaderConfig,
                    useValue: ngGoogleMapsLoaderConfig,
                },
                NgGoogleMapsLoaderService,
            ]
        };
    };
    return NgGoogleMapsLoaderModule;
}());
NgGoogleMapsLoaderModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [],
                declarations: [],
                exports: []
            },] },
];

exports.LoadStatus = LoadStatus;
exports.NgGoogleMapsLoaderService = NgGoogleMapsLoaderService;
exports.NgGoogleMapsLoaderModule = NgGoogleMapsLoaderModule;
exports.ɵa = NgGoogleMapsLoaderConfig;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-google-maps-loader.umd.js.map
